import 'package:syncrow_web/pages/device_managment/all_devices/models/device_status.dart';

class FlushMountedPresenceSensorModel {
  FlushMountedPresenceSensorModel({
    required this.presenceState,
    required this.farDetection,
    required this.illuminance,
    required this.sensitivity,
    required this.occurDistReduce,
    required this.noneDelay,
    required this.presenceDelay,
    required this.nearDetection,
    required this.sensiReduce,
    required this.checkingResult,
  });

  static const String codePresenceState = 'presence_state';
  static const String codeSensitivity = 'sensitivity';
  static const String codeNearDetection = 'near_detection';
  static const String codeFarDetection = 'far_detection';
  static const String codeCheckingResult = 'checking_result';
  static const String codePresenceDelay = 'presence_delay';
  static const String codeNoneDelay = 'none_delay';
  static const String codeOccurDistReduce = 'occur_dist_reduce';
  static const String codeIlluminance = 'illum_value';
  static const String codeSensiReduce = 'sensi_reduce';

  String presenceState;
  int sensitivity;
  int nearDetection;
  int farDetection;
  String checkingResult;
  int presenceDelay;
  int noneDelay;
  int occurDistReduce;
  int illuminance;
  int sensiReduce;

  factory FlushMountedPresenceSensorModel.fromJson(List<Status> jsonList) {
    var presenceState = 'none';
    var sensitivity = 0;
    var nearDetection = 0;
    var farDetection = 0;
    var checkingResult = 'none';
    var presenceDelay = 0;
    var noneDelay = 0;
    var occurDistReduce = 0;
    var illuminance = 0;
    var sensiReduce = 0;

    for (final status in jsonList) {
      switch (status.code) {
        case codePresenceState:
          presenceState = status.value ?? 'presence';
          break;
        case codeSensitivity:
          sensitivity = status.value ?? 0;
          break;
        case codeNearDetection:
          nearDetection = status.value ?? 0;
          break;
        case codeFarDetection:
          farDetection = status.value ?? 0;
          break;
        case codeCheckingResult:
          checkingResult = status.value ?? 'check_success';
          break;
        case codePresenceDelay:
          presenceDelay = status.value ?? 0;
          break;
        case codeNoneDelay:
          noneDelay = status.value ?? 0;
          break;
        case codeOccurDistReduce:
          occurDistReduce = status.value ?? 0;
          break;
        case codeIlluminance:
          illuminance = status.value ?? 0;
          break;
        case codeSensiReduce:
          sensiReduce = status.value ?? 0;
          break;
      }
    }

    return FlushMountedPresenceSensorModel(
      presenceState: presenceState,
      sensitivity: sensitivity,
      nearDetection: nearDetection,
      farDetection: farDetection,
      checkingResult: checkingResult,
      presenceDelay: presenceDelay,
      noneDelay: noneDelay,
      occurDistReduce: occurDistReduce,
      illuminance: illuminance,
      sensiReduce: sensiReduce,
    );
  }
}
