import 'package:syncrow_web/pages/device_managment/all_devices/models/device_status.dart';

class WallSensorModel {
  String presenceState;
  int farDetection;
  int presenceTime;
  int motionSensitivity;
  int motionlessSensitivity;
  int currentDistance;
  int illuminance;
  bool indicator;
  int noBodyTime;

  WallSensorModel(
      {required this.presenceState,
      required this.farDetection,
      required this.presenceTime,
      required this.motionSensitivity,
      required this.motionlessSensitivity,
      required this.currentDistance,
      required this.illuminance,
      required this.indicator,
      required this.noBodyTime});

  factory WallSensorModel.fromJson(List<Status> jsonList) {
    late String presenceState;
    late int farDetection;
    late int presenceTime;
    late int motionSensitivity;
    late int motionlessSensitivity;
    late int currentDistance;
    late int illuminance;
    late bool indicator;
    late int noBodyTime;

    for (var i = 0; i < jsonList.length; i++) {
      if (jsonList[i].code == 'presence_state') {
        presenceState = jsonList[i].value ?? 'none';
      } else if (jsonList[i].code == 'far_detection') {
        farDetection = jsonList[i].value ?? 0;
      } else if (jsonList[i].code == 'presence_time') {
        presenceTime = jsonList[i].value ?? 0;
      } else if (jsonList[i].code == 'motion_sensitivity_value') {
        motionSensitivity = jsonList[i].value ?? 0;
      } else if (jsonList[i].code == 'motionless_sensitivity') {
        motionlessSensitivity = jsonList[i].value ?? 0;
      } else if (jsonList[i].code == 'dis_current') {
        currentDistance = jsonList[i].value ?? 0;
      } else if (jsonList[i].code == 'illuminance_value') {
        illuminance = jsonList[i].value ?? 0;
      } else if (jsonList[i].code == 'indicator') {
        indicator = jsonList[i].value ?? false;
      } else if (jsonList[i].code == 'no_one_time') {
        noBodyTime = jsonList[i].value ?? 0;
      }
    }
    return WallSensorModel(
        presenceState: presenceState,
        farDetection: farDetection,
        presenceTime: presenceTime,
        motionSensitivity: motionSensitivity,
        motionlessSensitivity: motionlessSensitivity,
        currentDistance: currentDistance,
        illuminance: illuminance,
        indicator: indicator,
        noBodyTime: noBodyTime);
  }
}
